# Authors:
# Googie,
# Ciuciu,
# Sad Mephisto
#
# Beta Testers:
# Sajmon
# Blaze,
# Attis

# For developping - debugger to enable/disable:
# source $module(scriptpath)/debugger.tcl

# Versions of KaduPro and TCL module
set KaduProVersion $module(version)-$module(codename)

set req1 0.5
set req2 4

set ver1 [join [lrange [split $module(version) .] 0 1] .]
set ver2 [lindex [split $module(version) .] end]

if {$ver1 < $req1} {
    msgbox msg "Wersja moduu TCL jest za stara ($module(version)). Wymagana jest $req1.$req2."
} elseif {$ver1 == $req1 && $ver2 < $req2} {
    msgbox msg "Wersja moduu TCL jest za stara ($module(version)). Wymagana jest $req1.$req2."
}

# Encoding
if {[lsearch [encoding names] iso8859-2] > -1} {
    encoding system iso8859-2
} else {
    msgbox msg "Twoja instalacja biblioteki TCL (nie modulu!) nie pozwala\nna ustawienie kodowania znakow w standardzie ISO8859-2.\nMoze to powodowac niepoprawne wyswietlanie polskich znakow w KaduPro!"
}

# Block commenting
proc // {args} {return}

# Reading qtrc
if {[file readable $env(HOME)/.qt/qtrc]} {
    set fd [open $env(HOME)/.qt/qtrc r]
    set data [read $fd]
    close $fd
    set sw1 0
    set sw2 0
    foreach line [split $data "\n"] {
        if {$sw1} {
            set line [string map {^e ^} $line]
            set sp [split $line =]
            set type [lindex $sp 0]
            if {$sw2 > 3} {
                break
            } elseif {"active" == $type} {
                set sp2 [split [lindex $sp 1] ^]
                set QT_look(fg) [lindex $sp2 6]            ;# Foreground
                set QT_look(bg) [lindex $sp2 9]            ;# Background
                set QT_look(bt_fg) [lindex $sp2 8]         ;# Buttons foreground
                set QT_look(bt_bg) [lindex $sp2 1]         ;# Buttons background
                set QT_look(win_fg) [lindex $sp2 0]        ;# Windows foreground
                set QT_look(win_bg) [lindex $sp2 10]       ;# Windows background
                set QT_look(win_sel_fg) [lindex $sp2 13]   ;# Selected windows foreground
                set QT_look(win_sel_bg) [lindex $sp2 12]   ;# Selected windows background
                set QT_look(link) [lindex $sp2 14]         ;# Links
                set QT_look(visited) [lindex $sp2 15]      ;# Visited links
                set QT_look(bt_act_fg) "#"                 ;# Active buttons foreground
                set QT_look(bt_act_bg) "#"                 ;# Active buttons background
                for {set i 1} {$i < 7} {incr i} {
                    set c [scan [string index $QT_look(bt_bg) $i] "%x"]
                    if {$c < 15} {
                        incr c
                    }
                    append QT_look(bt_act_bg) [format "%x" $c]
    
                    set c [scan [string index $QT_look(bt_fg) $i] "%x"]
                    if {$c < 15} {
                        incr c
                    }
                    append QT_look(bt_act_fg) [format "%x" $c]
                }
    
                incr sw2
            }
        } else {
            if {"$line" == "\[Palette\]"} {
                set sw1 1
            }
        }
    }
}

# This code is for future versions. It enables theming TCL/TK and sets
# theme 'blue' as default:
#
# GUI
# foreach w {
#     label
#     menubutton
#     checkbutton
#     radiobutton
#     labelframe
#     frame
#     button
#     scrollbar
# } {
#     rename $w $w.bak
# }
# package require tile
# package require tile::theme::plastik
# namespace import ::tile::*
# style theme use plastik


# KP popup menu and configuration tab
set M(kadupro) "Kadu&Pro"
popup new $M(kadupro)

# Kadu configuration directory and data directory
set config_dir "$kadu(configdir)"

if {[file exists $kadu(datadir)/kadu/scripts/kadupro]} {
    set data_dir "$kadu(datadir)/kadu/scripts"
} else {
    set data_dir "$config_dir"
}
set kpicons "$module(scriptpath)/kadupro/icons"

# Default configuration
set RememberAdresses 10

# Loading KP components
set fileList {
    locale
    library
    status_table
    config
    shortcuts
    help
    clone
    words_fix
    notifier
    stats
    list
    addrmem
    antistrings
    misc
    board
    post-it
    statusplus
    autoresponder
    about
    control
    ~checknew
    lastseen
    translator
    translator_dict
}

foreach f $fileList {
    # If some component is for testing, you can start his name with '~' to disable loading him.
    if {[string index $f 0] != "~"} {
        source $module(scriptpath)/kadupro/scripts/$f.kkp
    }
}

# Loading configuration
if {[file exists $config_dir/kadupro.conf]} {
    source $config_dir/kadupro.conf
}

# Adding KP popup to Kadu menu bar,
# some finishing things
if {$showSplash} {showSplashScreen}  ;# splash screen
qmenu new $M(kadupro)                ;# main KP menu
autoresponder_update_fixed_list      ;# autoresponder list
update_fixed_list                    ;# status+ list
remakeClonesMenu                     ;# clones list
setup_postit_timers                  ;# Display post-it notes during startup
enable_sound_notify		     ;# enable notify_by_sound timer.. ugly workaround :(
if { $statusplus(loop_active) } {    ;# Status changes obserwer
    set statusplus(loop_active) 0
    change_statusloop 
}
